cls
clear
import excel SP500.xlsx, first

///QUESTION 1

*log using sp500log

*this do file can handle different types of thresholds (including structural breaks)
*by defining dummy variables as appropriate

tsset months, monthly

generate logSP500 = log(SP500)
generate CH_SP500 = D.logSP500

tsline CH_SP500, xtitle("") title("% Change in S&P500")

///AR(1) MODEL------------------------------------------------------------------

regress CH_SP500 L.CH_SP500

///INFORMATION CRITERIA

estat ic

*following material for TAR model-----------------------------------------------
generate SP_thresh1 = 0
replace SP_thresh1 = CH_SP500 if CH_SP500>0

///BREAK IN MEAN (HOMOSKEDASTIC TAR)

regress CH_SP500 L.CH_SP500 L.SP_thresh1
estat ic

///BREAK IN MEAN AND VARIANCE (HETEROSKEDASTIC TAR)

///Post-break data

regress CH_SP500 L.CH_SP500 if L.CH_SP500>=0
estat ic

///Pre-break data

regress CH_SP500 L.CH_SP500 if L.CH_SP500 <0
estat ic


///Using Stata Threshold function - tau is estimated
threshold CH_SP500, regionvars(l.CH_SP500) threshvar(l.CH_SP500)

///SUM IC FOR PRE AND POST BREAK TO OBTAIN IC FOR MODEL WITH BREAK IN MEAN AND VARIANCE

///PART F

sum CH_SP500

generate z1 = (L.CH_SP500 - 0.005303)^2 
generate z2 = (CH_SP500 - 0.005303)^2

sum z1
sum z2

generate SP_thresh2 = 0
replace SP_thresh2 = CH_SP500 if z2> .0012676 

///BREAK IN MEAN (HOMOSKEDASTIC TAR)

regress CH_SP500 L.CH_SP500 L.SP_thresh2
estat ic

///BREAK IN MEAN AND VARIANCE (HETEROSKEDASTIC TAR)

///Post-break data

regress CH_SP500 L.CH_SP500 if z1>=.0012694
estat ic

///Pre-break data

regress CH_SP500 L.CH_SP500 if z1<.0012694
estat ic

///Using Stata Threshold function - tau is estimated
threshold CH_SP500, regionvars(l.CH_SP500) threshvar(z1)