cls
clear

import excel macro_data_DFM.xlsx, first
tsset months, monthly

//PART A

generate l_income = log(RPI)
generate ld_income = D.l_income

generate l_ip = log(INDPRO)
generate ld_ip = D.l_ip

generate l_employ = log(PAYEMS)
generate ld_employ = D.l_employ


*generate l_house = log(HOUST)
*generate l_money = log(M2REAL)

generate l_SP500 = log(SP500)
generate ld_SP500 = D.l_SP500

//Part B
//WE WANT:  P=1(ONE LAG IN THE FACTOR EQN), Q=1(ONE LAG IN THE 'ERROR EQUATION'), M=1 (ONE FACTOR)

dfactor (ld_income ld_ip ld_employ ld_SP500 = , ar(1)) (f= , ar(1))
predict factor1, factors smethod(smooth) rmse(rmse)
scalar z = invnormal(.95)
gen lb = factor1 - z*(rmse)
gen ub = factor1 + z*(rmse)
estat ic
// tsline factor1 lb ub, xtitle("") title("Factor: Smoothed Estimate with 95% confidence interval")
// graph export Figure1.png

// Filtered estimates
// predict factor1, factors smethod(filter) rmse(rmse1)
// gen lb1 = factor1 - z*(rmse1)
// gen ub1 = factor1 + z*(rmse1)
// estat ic
// tsline factor1 lb1 ub1, xtitle("") title("Factor: Filtered Estimate with 95% confidence interval")


//PART C

//WE WANT: P=0 (NO LAGS IN FACTOR EQUATION), Q=1(ONE LAG IN THE 'ERROR EQUATION'), M = 1 (ONE FACTOR)

// dfactor (ld_income ld_ip ld_employ ld_SP500 = , ar(1)) (f= , )
// predict factor1, factors smethod(smooth) rmse(rmse1)
// estat ic
// tsline factor1, xtitle("") title("Factor: Smoothed Estimate")
// scalar z = invnormal(.95)
// gen lb = factor1 - z*(rmse1)
// gen ub = factor1 + z*(rmse1)
// estat ic
// tsline factor1 lb ub, xtitle("") title("Factor: Smoothed Estimate with 95% confidence interval")
// graph export Figure2.png

//PART D

//WE WANT: P=0 (NO LAGS IN FACTOR EQUATION), Q = 0 (NO LAGS IN 'ERROR EQUATION'), M = 1 (ONE FACTOR)

dfactor (ld_income ld_ip ld_employ ld_SP500 = ,ar(1) ) (f= , )
predict factor1, factors smethod(smooth)  rmse(rmse2)
estat ic
scalar z = invnormal(.95)
gen lb = factor1 - z*(rmse2)
gen ub = factor1+ z*(rmse2)
estat ic
tsline factor1 lb ub, xtitle("") title("Factor: Smoothed Estimate with 95% confidence interval")
// graph export Figure3.png
